//	+---------------------------+
//	|	Server Music			|
//	+---------------------------+
//	|	Version: 3.0			|
//	|	Released: October 2		|
//	|	Author: Zapk | 12270	|
//	+---------------------------+

//	Define Variables
$SM::TemporaryMusicFile = "config/server/ServerMusic/list.dat";
$SM::Version = "2.0";
$SM::PlayersCanVote = true;

//	Return to Blockland Variables
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)	exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Allow Music Voting","Server Music","Pref::SM::AllowVoting","bool","Server_ServerMusic",1,0,0);
}
else
{
	$Pref::SM::AllowVoting = true;
}

//	Load Support_AdminEvents
exec("./Support_AdminEvents.cs");

//	Register Wrench Events
registerOutputEvent(fxDTSBrick, setServerMusic, "list Random 0 Selection 1" TAB "datablock Music", "bool");
registerAdminOnlyOutputEvent(fxDTSBrick, setServerMusic, 1);

//	Wrench Events
function fxDTSBrick::setServerMusic(%this,%choice,%data)
{
	if(%data > 0)
		%profile = %data.getName();
		
	if(%profile $= "" && %choice == 1)
	{
		SM_StopSong();
		return;
	}
	if(%choice == 0)
	{
		SM_PlayRandomSong();
	}
	if(%choice == 1)
	{
		SM_PlaySong("", %profile);
	}
}

//	Musical Functions
function SM_StopSong()
{
	if(isObject(SM_Music))
	{
		SM_Music.delete();
	}
}

function SM_PlaySong(%client, %profile)
{
	%message = strReplace(%profile, "musicData_", "");
	%message = strReplace(%message, "_", " ");
	%message = strReplace(%message, "DASH", "-");
	if(isObject(%client.player))
	{
		messageAll('', "\c4" @ %client.name SPC "\c6changed the song to\c4" SPC %message);
	}
	else
	{
		messageAll('', "\c6Now playing\c4" SPC %message);
	}
	bottomPrintall("<font:impact:26>\c4Server Music<just:right>\c6Now playing:\c4" SPC %message SPC "", 3, true);
	
	SM_StopSong();
	
	new AudioEmitter(SM_Music)
	{
		position = "0 0 0";
		profile = %profile;
		useProfileDescription = "0";
		description = "AudioLooping2D";
		type = "0";
		volume = "1";
		outsideAmbient = "1";
		ReferenceDistance = "4";
		maxDistance = "9001";
		isLooping = "1";
	};
}

function SM_PlayRandomSong()
{
	%fileName = $SM::TemporaryMusicFile;
	if(isFile(%fileName))
	{
		fileDelete(%fileName);
	}
	export("$Music__*", %fileName);
	%old = new fileObject();
	
	%old.openForRead("config/server/musicList.cs");
	while(!%old.isEOF())
	{
		%line = %old.readLine();
		%lineCt++;
		$SM::Random_Line[%lineCt] = %line;
	}
	%old.close();
	%old.delete();
	
	%new = new fileObject();
	
	%new.openForWrite(%fileName);
	%new.writeLine("//This is the music profile list generated by Server_ServerMusic. Do not modify.");
	$SM::Random_SongCount = 0;
	for(%a = 0; %a < %lineCt; %a++)
	{
		%line = $SM::Random_Line[%a];
		%line = strReplace(%line, "$Music__", "");
		%filename = strReplace(%line, "DASH", "-");
		%filename = strReplace(%filename, " = 1;", "");
		if(getWord(%line, 2) $= "1;" && isFile("Add-Ons/Music/" @ %filename @ ".ogg"))
		{
			%line = strReplace(%line, " = 1;", "");
			%line = "musicData_" @ %line;
			$SM::Random_SongCount++;
			$SM::Random_Song[$SM::Random_SongCount] = %line;
			%new.writeLine(%line);
		}
	}
	
	%rand = getRandom(1, $SM::Random_SongCount);
	%music = $SM::Random_Song[%rand];
	SM_PlaySong("", %music);
	
	%new.close();
	%new.delete();
}

//	Server Commands
function serverCmdMusic(%client)
{
	if(!%client.isAdmin)
	{
		messageClient(%client, '', "\c6You are not an admin!");
		messageClient(%client, '', "\c6Type \c4/vm \c6to vote instead!");
		return;
	}
	if(isObject(%client.serverMusicHandler))
	{
		%client.serverMusicHandler.delete();
	}
	if(!isObject(%client.serverMusicHandler))
	{
		%client.serverMusicHandler = new fxDTSBrick()
		{
			client = %client;
			dataBlock = brickMusicData;
			isPlanted = true;
			isServerMusic["Admin"] = true;
			mount = %client.player;
			position = "-10000 -10000 -10000";
		};
	}
	%client.wrenchBrick = %client.serverMusicHandler;
	%client.wrenchBrick.sendWrenchSoundData(%client);
	commandToClient(%client,'openWrenchSoundDlg',"Server Music",1);
}

//	Package
if(isPackage(ServerMusic))
{
	deactivatePackage(ServerMusic);
}
package ServerMusic
{
	function serverCmdSetWrenchData(%client,%data)
	{
		if(%client.wrenchBrick.isServerMusic["Admin"])
		{
			if(isObject(%client.wrenchBrick.mount))
			{
				if(getWord(getField(%data,1),1) $= "0")
				{
					if(isObject(SM_Music))
					{
						messageAll('', "\c4" @ %client.name SPC "\c6stopped the music.");
					}
					SM_StopSong();
				}
				else
				{
					SM_PlaySong(%client, getWord(getField(%data,1),1).getName());
				}
			}
			%client.serverMusicHandler.delete();
		}
		else if(%client.wrenchBrick.isServerMusic["Vote"])
		{
			if(isObject(%client.wrenchBrick.mount))
			{
				if(getWord(getField(%data,1),1) $= "0")
				{
					SM_ParseVoteSelection(%client, "None");
				}
				else
				{
					SM_ParseVoteSelection(%client, getWord(getField(%data,1),1).getName());
				}
			}
			%client.serverMusicHandler.delete();
		}
		else
		{
			Parent::serverCmdSetWrenchData(%client,%data);
		}
	}
};
activatePackage(ServerMusic);

//	Voting Functions
function SM_SetPCV(%this)
{
	$SM::PlayersCanVote = %this;
	if(%this)
	{
		if(!$Pref::SM::AllowVoting)
		{
			return;
		}
		messageAll('', "\c6Players may now vote to change the song again. \c4/vm");
	}
}

function SM_ResetVoters()
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%client = ClientGroup.getObject(%a);
		%client.SM_HasVoted = false;
	}
}

function SM_ParseVote(%client)
{
	if(!$Pref::SM::AllowVoting)
	{
		return;
	}
	if(%client.SM_HasVoted)
	{
		return;
	}
	$SM::VoteCount++;
	%client.SM_HasVoted = true;
	%song = $SM::VoteSongName;
	%requiredVotes = (mFloor(ClientGroup.getCount() / 2) - $SM::VoteCount) + 1;
	messageAll('', "\c4" @ %client.name SPC "\c6voted to play\c4" SPC %song @ "\c6. Type \c4/vm\c6 to concur.");
	bottomPrintall("<font:impact:26>\c4Server Music<just:right>\c6Votes:\c4" SPC $SM::VoteCount SPC "\c6Required:\c4" SPC %requiredVotes @ "<br>\c6Voting for:\c4" SPC %song SPC "", 3, true);
	if(%requiredVotes <= 0)
	{
		SM_StopVote();
	}
}

function SM_StopVote()
{
	if(!$Pref::SM::AllowVoting)
	{
		return;
	}
	cancel($SM_StopVoteSchedule);
	SM_SetPCV(false);
	cancel($SM_SetPCVSchedule);
	$SM_SetPCVSchedule = schedule(30000, 0, SM_SetPCV, true);
	SM_ResetVoters();
	%clientCount = ClientGroup.getCount();
	%yesVotes = $SM::VoteCount;
	%antiVotes = %clientCount - %yesVotes;
	if(%yesVotes > %antiVotes)
	{
		%profile = $SM::VoteSongProfile;
		if(%profile $= "None")
		{
			schedule(1000, 0, SM_StopSong);
		}
		else
		{
			schedule(1000, 0, SM_PlaySong, "", %profile);
		}
		messageAll('MsgProcessComplete', "\c6The music vote succeeded, setting song...");
		bottomPrintall("<font:impact:26>\c4Server Music<just:right>\c6Vote Succeeded" SPC "", 3, true);
	}
	else
	{
		messageAll('MsgUploadEnd', "\c6The music vote has failed.");
		bottomPrintall("<font:impact:26>\c4Server Music<just:right>\c6Vote Failed" SPC "", 3, true);
	}
	$SM::VoteInProgress = false;
	$SM::VoteCount = 0;
}

function serverCmdVM(%client)
{
	if(!$Pref::SM::AllowVoting)
	{
		messageClient(%client, '', "\c6Music voting is disabled.");
		return;
	}
	if(!$SM::PlayersCanVote)
	{
		messageClient(%client, '', "\c6You may not start a new vote yet.");
		return;
	}
	if(%client.SM_HasVoted)
	{
		messageClient(%client, '', "\c6You have already voted!");
		return;
	}
	if($SM::VoteInProgress)
	{
		SM_ParseVote(%client);
	}
	else
	{
		messageClient(%client, '', "\c6Please pick a song to start a vote.");
		if(isObject(%client.serverMusicHandler))
		{
			%client.serverMusicHandler.delete();
		}
		if(!isObject(%client.serverMusicHandler))
		{
			%client.serverMusicHandler = new fxDTSBrick()
			{
				client = %client;
				dataBlock = brickMusicData;
				isPlanted = true;
				isServerMusic["Vote"] = true;
				mount = %client.player;
				position = "-10000 -10000 -10000";
			};
		}
		%client.wrenchBrick = %client.serverMusicHandler;
		%client.wrenchBrick.sendWrenchSoundData(%client);
		commandToClient(%client,'openWrenchSoundDlg',"Music Vote",1);
	}
}

function SM_ParseVoteSelection(%client, %profile)
{
	if(!$Pref::SM::AllowVoting)
	{
		messageClient(%client, '', "\c6Music voting is disabled.");
		return;
	}
	if($SM::VoteInProgress)
	{
		messageClient(%client, '', "\c6Sorry, somebody started a vote already!");
		return;
	}
	$SM::VoteInProgress = true;
	%message = strReplace(%profile, "musicData_", "");
	%message = strReplace(%message, "_", " ");
	%message = strReplace(%message, "DASH", "-");
	$SM::VoteSongName = %message;
	$SM::VoteSongProfile = %profile;
	
	$SM_StopVoteSchedule = schedule(60000, 0, SM_StopVote);
	
	messageAll('', "\c6A music vote has been started. It will end in 1 minute.");
	
	SM_ParseVote(%client);
}